Attribute VB_Name = "MVb6Functions"
' *************************************************************************
' Adopted from:
' Implement VB6 string functions in VB5 (Improved Over MSKB Version)
' http://www.freevbcode.com/ShowCode.Asp?ID=17
' *************************************************************************
' VB6 functions for VB5...
'   Split         Split a string into a variant array.
'   InStrRev      Similar to InStr but searches from end of string.
'   Replace       To find a particular string and replace it.
'   Reverse       To reverse a string.
' *************************************************************************
Option Explicit

Public Function InStrRev(ByVal StringCheck As String, ByVal StringMatch As String, Optional Start As Long = 1, Optional Compare As VbCompareMethod = vbBinaryCompare) As Long
   Dim nPos As Long
   
   StringCheck = StrReverse(StringCheck)
   StringMatch = StrReverse(StringMatch)
   
   nPos = InStr(Start, StringCheck, StringMatch, Compare)
   If nPos = 0 Then
      InStrRev = 0
   Else
      InStrRev = Len(StringCheck) - nPos - Len(StringMatch) + 2
   End If
End Function

Public Function Join(SourceArray() As String, Optional Delimiter As String = " ") As String
   Dim i As Long
   Dim sRet As String
   
   For i = LBound(SourceArray) To UBound(SourceArray) - 1
      sRet = sRet & SourceArray(i) & Delimiter
   Next
   Join = sRet & SourceArray(i)
End Function

Public Function Replace(ByVal Expression As String, ByVal Find As String, ByVal Replase As String, Optional Start As Long = 1, Optional Count As Long = -1, Optional Compare As VbCompareMethod = vbBinaryCompare) As String
   Dim nC As Long, nPos As Long
   Dim nFindLen As Long, nReplaceLen As Long

   nFindLen = Len(Find)
   nReplaceLen = Len(Replase)
   
   If (Find <> "") And (Find <> Replase) Then
      nPos = InStr(Start, Expression, Find, Compare)
      Do While nPos
         nC = nC + 1
         Expression = Left(Expression, nPos - 1) & Replase & Mid(Expression, nPos + nFindLen)
         If Count <> -1 And nC >= Count Then Exit Do
         nPos = InStr(nPos + nReplaceLen, Expression, Find, Compare)
      Loop
   End If

   Replace = Expression
End Function

Public Function StrReverse(ByVal Expression As String) As String
   Dim i As Long
   Dim sRet As String
   
   For i = Len(Expression) To 1 Step -1
      sRet = sRet & Mid(Expression, i, 1)
   Next i
   StrReverse = sRet
End Function

Public Function Split(ByVal Expression As String, Optional Delimiter As String = " ", Optional Limit As Long = -1, Optional Compare As VbCompareMethod = vbBinaryCompare) As Variant
   Dim i As Long, nPos As Long, nDelimLen As Long
   Dim sRet() As String
   
   If Delimiter <> "" Then
      nDelimLen = Len(Delimiter)
      nPos = InStr(1, Expression, Delimiter, Compare)
      Do While nPos
         ReDim Preserve sRet(0 To i)
         sRet(i) = Left(Expression, nPos - 1)
         Expression = Mid(Expression, nPos + nDelimLen)
         i = i + 1
         If Limit <> -1 And i >= Limit Then Exit Do
         nPos = InStr(1, Expression, Delimiter, Compare)
      Loop
   End If
   
   ReDim Preserve sRet(0 To i)
   sRet(i) = Expression
   
   Split = sRet
End Function


